# Note Access

![Screenshot](/images/screenshot.png)

Provides per-contact access levels to view specific notes.

For permissions based on roles, see: https://civicrm.org/extensions/note-permissions

The extension is licensed under [AGPL-3.0](LICENSE.txt).

## Requirements

* PHP v7.4+
* CiviCRM 5.60+

## Installation

Install as a regular CiviCRM extension.

## Getting Started

When editing a note, it adds a new option to select "Specific People", which then displays a new field with a contact auto-complete.

There are a few important changes in the behaviour around notes:

- When viewing a contact and there are hidden notes, it will display the date, subject and author of the note.
- Regardless of the privacy levels, notes cannot be deleted by anyone other than the note author, or by administrators with the "view all notes" permission.

## Known Issues

- Notes will always be hidden in contact exports, because we currently cannot check their privacy settings in the export.
- There are issues with the "specific-contacts" autocomplete, working on it.
- Notes can still be edited/deleted using the API Explorer (ex: change the privacy level).

## Support

Please post bug reports in the issue tracker of this project on CiviCRM's Gitlab:  
https://lab.civicrm.org/extensions/noteaccess/issues

While we do our best to provide community support for this extension, please
consider financially contributing to support or development of this extension
if you can.

Support via Coop SymbioTIC:  
https://www.symbiotic.coop/en

Coop Symbiotic is a worker-owned co-operative based in Canada. We have a strong
experience working with non-profits and CiviCRM. We provide affordable, fast,
turn-key hosting with regular upgrades and proactive monitoring, as well as
custom development and training.
